﻿function GetPluginSettings()
{

	//\\//		Backyard door to JavaScript objects.
	//			help:
	//				flags ... val. ranges ... http://c2community.ru/forum/viewtopic.php?p=22177
	//				start here: https://www.scirra.com/manual/69/plugins
	//				https://www.scirra.com/manual/108/array

	//			version 1.1 is slightly polluted with extra "sugar" method comparing with version 1.0
	//			version 1.2 proofread
	//			version 1.3 deep assigment and "retrieval" added;	"object-backdoor" began but not time to finish;
	//			version 1.4 polished;
	//			version 1.6 July 20, 2014: fix for object.child.string.length for "get" expression;
	//			veraion 1.7 July 23. eval( );
	//			veraion 1.8 July 26. taken from Jsob 1.7;
	//			veraion 1.10 July 26. half-works with btb.grid lib;
	//			veraion 1.11 July 26. add cross domain script
	//			veraion 1.13 July 26. bug of ix in actions is fixed; 
	//					test commands from c2:
	//						"grid.init"
	//						"grid.snap2isoGrid marshland 2 784 85"
	//			veraion 1.14 July 26. gridifier is removed to project-external files;
	//			veraion 1.15 July 26. principal changes
	//			veraion 1.16b August 21. Comments;
	//			veraion 1.17  Oct. 8, 2014. Comment in IDE;


	//			The name "btb" means "Beaver Tool Belt".
	//			This code is loosely based on these fragmets of btb:
	//					https://github.com/lancelab/spaceen/tree/master/js/btb
	//					http://www.funderstanding.com/educators/coaster/
	//						http://www.funderstanding.com/wp-content/themes/boilerplate/cstr/prod-js/sapp.js


	return {
		"name":			"Btb",
		"id":			"Btb",
		"version":		"1.17",
		"description":	"C2-front-end to JavaScript objects: interacting with tree, inject cross-domain script, functions return objects;",
		"author":		"2014 (c) Konstantin Kirillov. Landkey.net. License: MIT.",
		"help url":		"http://landkey.net/help-is-not-documented-yet",
		"category":		"Data & Storage",
		"type":			"object",			// not in layout
		"rotatable":	false,
		"flags":		0
	};
};






// //\\	Actions		////////////////////////////////////////////

//					This is maybe redundant because c2 maybe have similar action
AddStringParam(		"command", "command to evaluate" );
AddAction(			0, 0, "eval", "Run", "eval( {0} )", "Evaluates command", "evaluateCommand");

AddStringParam(		"path", "path to descendant" );
AddAnyTypeParam(	"value", "value to store in the descendant" );
AddAction(			1, 0, "set", "Update", "<i>[{0}]</i> = <i>{1}</i>", "Set the value of descendant in the object tree.", "set");

AddStringParam(		"operands", "function-path and its input params space separated" );
AddAction(			2, 0, "rin", "Run", "rin( {0} )", "Executes function on arguments", "rin");

AddStringParam(		"url", "URL or path to script" );
AddAction(			3, 0, "addscript", "Run", "addscript {0} ", "Injects cross-domain script", "appendScript");

AddStringParam(		"json", "A string of the JSON-data to load.");
AddAction(			4, 0, "json2ob", "Update", "=<i>{0}-to-ob</i>", "Load JSON literal.", "json2ob");

///	this is a plugin-sugar: getting subtree:
AddStringParam(		"path", "The path to retrieved descendant." );
AddStringParam(		"json", "A string of the JSON-data to dig." );
AddAction(			5, 0, "json2path", "Update", "=<i>{1}[{0}]</i>", "Convert from JSON and load its subtree by path.", "json2path");

//	AddAction(		2, 0, "Delete", "Misc", "Delete", "Delete. Idle: not yet implemented.", "Delete");
//	AddAction(		0, 0, "Clear", "Update", "Clear", "Remove first-level references to children", "Clear");
// \\//	Actions		////////////////////////////////////////////







//	//\\ Expressions		//////////////////////////////////////////////////////////////
//							no objects can be returned? https://www.scirra.com/forum/returning-an-object-array-expression_t90482


AddStringParam(	"path", "The path to retrieved descendant.", "0");
AddExpression(	0,
				ef_return_any | ef_variadic_parameters,
				"Get value at",
				"get",
				"get",
				"Get value from the object's descendant."
);


AddStringParam(	"path", "The path to retrieved btb.pass.path after rin did run.", "0");
AddExpression(	0,
				ef_return_any | ef_variadic_parameters,
				"Get value at",
				"rout",
				"rout",
				"Retrieves btb.pass.path."
);

AddExpression(	1,
				ef_return_string,
				"ob2json",
				"get",
				"ob2json",
				"Return the contents of the object as JSON-literal."
);

AddStringParam(	"path", "The path to retrieved descendant.", "");
AddExpression(	2,
				ef_return_string,
				"path2json",
				"get",
				"path2json",
				"Return descendant-at-path as JSON-literal."
);
AddExpression(	3, ef_return_string, "Current property name", "For Each", "CurName", "Get the current prop. name in a For Each loop.");
AddExpression(	4, ef_return_any, "Current property value", "For Each", "CurValue", "Get the current value in a For Each loop.");


//	\\// Expressions		//////////////////////////////////////////////////////////////



//	//\\	Conditions		//////////////////////////////
AddCondition( 0, cf_looping, "For each element", "For Each", "For each element", "Repeat the event for each proper child element in object.", "forEach");
//	\\//	Conditions		//////////////////////////////





ACESDone();



// Property grid properties for this plugin
var property_list = [
		// new cr.Property(ept_integer, 	"My property",		77,		"An example property.")
		//	new cr.Property(ept_integer,		"Width",		10,			"Initial number of elements on the X axis."),
	];

	
// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
	return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance, this);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
	
	// Save the constructor parameters
	this.instance = instance;
	this.type = type;
	
	// Set the default property values from the property table
	this.properties = {};
	
	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;
}

// Called by the IDE after all initialization on this instance has been completed
IDEInstance.prototype.OnCreate = function()
{
}

// Called by the IDE after a property has been changed
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}
	
// Called by the IDE to draw this instance in the editor
IDEInstance.prototype.Draw = function(renderer)
{
}

// Called by the IDE when the renderer has been released (ie. editor closed)
// All handles to renderer-created resources (fonts, textures etc) must be dropped.
// Don't worry about releasing them - the renderer will free them - just null out references.
IDEInstance.prototype.OnRendererReleased = function()
{
}
