﻿function GetPluginSettings()
{

	//\\//		Lightweight JS object wrapper.
	//			help:
	//				flags ... val. ranges ... http://c2community.ru/forum/viewtopic.php?p=22177
	//				start here: https://www.scirra.com/manual/69/plugins
	//				https://www.scirra.com/manual/108/array

	//			version 1.1 is slightly polluted with extra "sugar" method comparing with version 1.0
	//			version 1.2 proofread
	//			version 1.3 deep assigment and "retrieval" added;	"object-backdoor" began but not time to finish;
	//			version 1.4 polished;
	//			version 1.6 July 20, 2014: fix for object.child.string.length for "get" expression;
	//			veraion 1.7 July 23. eval( );
	//			veraion 1.10
	//			veraion 1.11 Minor comment in IDE;
	//			veraion 1.12 Minor comment in IDE; Oct. 30, 2014.
	//			veraion 1.13 Get value at url-query key-path. get_url_key_value. Nov. 13, 2014.

	return {
		"name":			"Jsob",
		"id":			"Jsob",
		"version":		"1.9",	//	setting 	"version":		"1.12", causes "chicken and hen" problem in c2; 
								//	c2 says: "... update your project .. before loading this project ... how can one update a project without loading it? ..."
								//	this is a dead end;

		"description":	"Stores JavaScript object.",
		"author":		"2014 (c) Konstantin Kirillov. Landkey.net. License: MIT.",
		"help url":		"http://landkey.net/help-is-not-documented-yet",
		"category":		"Data & Storage",
		"type":			"object",			// not in layout
		"rotatable":	false,
		"flags":		0
	};
};






// //\\	Actions		////////////////////////////////////////////

//AddStringParam(		"command", "command to evaluate" );
//AddAction(			0, 0, "run", "Run", "run( {0} )", "Evaluates command", "evaluateCommand");

AddStringParam(		"path", "path to descendant;" );
AddAnyTypeParam(	"value", "value to store in the descendant" );
AddAction(			0, 0, "set", "Update", "<i>[{0}]</i> = <i>{1}</i>", "Set the value of descendant in the object tree.", "set");

AddStringParam(		"json", "A string of the JSON-data to load.");
AddAction(			1, 0, "json2ob", "Update", "=<i>{0}-to-ob</i>", "Load JSON literal.", "json2ob");

///	this is a plugin-sugar: getting subtree:
AddStringParam(		"path", "The path to subnode" );
AddStringParam(		"json", "JSON-of-object to apply the path" );
AddAction(			2, 0, "json2path", "Update", "=<i>{1}.{0}</i>", "Assign subnode from JSON.", "json2path");

//	AddAction(		2, 0, "Delete", "Misc", "Delete", "Delete. Idle: not yet implemented.", "Delete");
//	AddAction(		0, 0, "Clear", "Update", "Clear", "Remove first-level references to children", "Clear");
// \\//	Actions		////////////////////////////////////////////







//	//\\ Expressions		//////////////////////////////////////////////////////////////
//							no objects can be returned? https://www.scirra.com/forum/returning-an-object-array-expression_t90482
AddStringParam(	"path", "The path to retrieved descendant.", "0");
AddExpression(	0,
				ef_return_any | ef_variadic_parameters,
				"Get value at",
				"get",
				"get",
				"Get value from the object's descendant."
);

AddExpression(	1,
				ef_return_string,
				"ob2json",
				"get",
				"ob2json",
				"Return the contents of the object as JSON-literal."
);

AddStringParam(	"path", "The path to retrieved descendant.", "");
AddExpression(	2,
				ef_return_string,
				"path2json",
				"get",
				"path2json",
				"Return descendant-at-path as JSON-literal."
);
AddExpression(	3, ef_return_string, "Current property name", "For Each", "CurName", "Get the current prop. name in a For Each loop.");
AddExpression(	4, ef_return_any, "Current property value", "For Each", "CurValue", "Get the current value in a For Each loop.");


AddStringParam(	"path", "The path to retrieved descendant.", "0");
AddExpression(	5,
				ef_return_any | ef_variadic_parameters,
				"Get value at url-query key-path",
				"get_url_key_value",
				"get_url_key_value",
				"Get value at url-query key-path."
);
//	\\// Expressions		//////////////////////////////////////////////////////////////



//	//\\	Conditions		//////////////////////////////
AddCondition( 0, cf_looping, "For each element", "For Each", "For each element", "Repeat the event for each proper child element in object.", "forEach");
//	\\//	Conditions		//////////////////////////////





ACESDone();



// Property grid properties for this plugin
var property_list = [
		// new cr.Property(ept_integer, 	"My property",		77,		"An example property.")
		//	new cr.Property(ept_integer,		"Width",		10,			"Initial number of elements on the X axis."),
	];

	
// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
	return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance, this);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
	
	// Save the constructor parameters
	this.instance = instance;
	this.type = type;
	
	// Set the default property values from the property table
	this.properties = {};
	
	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;
}

// Called by the IDE after all initialization on this instance has been completed
IDEInstance.prototype.OnCreate = function()
{
}

// Called by the IDE after a property has been changed
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}
	
// Called by the IDE to draw this instance in the editor
IDEInstance.prototype.Draw = function(renderer)
{
}

// Called by the IDE when the renderer has been released (ie. editor closed)
// All handles to renderer-created resources (fonts, textures etc) must be dropped.
// Don't worry about releasing them - the renderer will free them - just null out references.
IDEInstance.prototype.OnRendererReleased = function()
{
}
